
putlog "-"
putlog "Beginning of a loading IRC-Arena"
putlog "-"

###      (, , ...)
set linkrules "http://twin.net.ru/arena/"

set arenadir "scripts/mc/"

source ${arenadir}mc.misc.tcl

if { ![array exist mc] || ![info exist mc(ver)]} {
    set mc(ver) "2.1.3"
    set mc(cop) "IRC-Arena \[$mc(ver)\]"

    set mc(phase) 0
    set mc(flags) ""

    set mc(alreadyhtml) 1

    set noreg 0
    cleartimers
    utimer 1 {
        mc:log "Maiden start - Auto-rehash"
        rehash
    }
}

set mc(gametype) 1

set mc(rules) "${arenadir}rules.txt"
set mc(file.base) "bots/arena.$network.$nick.base"
set mc(file.skil) "bots/arena.$network.$nick.skill"
set mc(file.coms) "bots/arena.$network.$nick.coms"
set mc(file.save) "bots/arena.$network.$nick.save"
set mc(file.drop) "bots/arena.$network.$nick.drop"
set mc(file.nexp) "bots/arena.$network.$nick.nexp"
set mc(file.bots) "bots/arena.$network.$nick.bots"
set mc(file.host) "bots/arena.$network.$nick.host"
set mc(file.conf) "bots/arena.$network.$nick.conf"
set mc(file.recs) "bots/arena.$network.$nick.records"
set mc(file.nlog) "bots/arena.$network.$nick.nlog"
set mc(file.phtml) "${arenadir}players.stats"
set mc(file.chtml) "${arenadir}coms.stats"
set mc(file.weath) "${arenadir}weather.conf"
set mc(file.skill) "${arenadir}skill.conf"
set mc(file.shop)  "${arenadir}shop/"
set mc(file.mage)  "${arenadir}"

source ${arenadir}mc.config.tcl
source ${arenadir}mc.defconf.tcl
source ${arenadir}mc.theme.tcl
source ${arenadir}mc.utils.tcl
source ${arenadir}mc.user.tcl
source ${arenadir}mc.binds.tcl
source ${arenadir}mc.reg.tcl
source ${arenadir}mc.game.tcl
source ${arenadir}mc.shop.tcl
source ${arenadir}mc.round.tcl
source ${arenadir}mc.rmisc.tcl
source ${arenadir}mc.irc.tcl
source ${arenadir}mc.com.tcl
source ${arenadir}mc.ctools.tcl
source ${arenadir}mc.twin.tcl
source ${arenadir}mc.senna.tcl
source ${arenadir}mc.hosts.tcl
source ${arenadir}mc.telnet.tcl
source ${arenadir}mc.pool.tcl
source ${arenadir}mc.magic.tcl
source ${arenadir}mc.skill.tcl
source ${arenadir}mc.cskill.tcl
source ${arenadir}mc.constants.tcl
source ${arenadir}mc.esets.tcl
source ${arenadir}mc.favor.tcl
source ${arenadir}mc.collect.tcl
source ${arenadir}mc.talisman.tcl
source ${arenadir}mc.spec.tcl
source ${arenadir}mc.mode.tcl
source ${arenadir}mc.html.tcl
source ${arenadir}mc.savelist.tcl
source ${arenadir}mc.transfer.tcl
source ${arenadir}mc.weather.tcl
source ${arenadir}mc.debug.tcl
source ${arenadir}mc.update.tcl

if { ![array exist mcs] } {
    mc:read
    mc:readrecords
    mc:calcaveragelevel
}

#source ${arenadir}mc.public.tcl
#source ${arenadir}mc.botnet.tcl
#source ${arenadir}mc.create.tcl
#source ${arenadir}mc.update.tcl

#source ${arenadir}mc.total.server.tcl
#source ${arenadir}mc.total.client.tcl
#source ${arenadir}mc.total.theme.tcl

mc:config:load
mc:skill:load
mc:shop:load
mc:weather:load
mc:magic:load
mc:telnet:init

mc:setbinds "$mc(chan)"

putlog "-"
putlog "ArenaVer : $mc(ver)"
putlog "BotAdmin : $admin"
putlog "DropVer  : [lindex $version 0]"
putlog "-"
putlog "IRC-Arena is loaded."
putlog "-"
