
proc mc:mrun {n uh h t} {
    global mcs mc ct cth mcr mcc mce ts tl ti tv th ta tg te todo liv param prc
    global col
    global allowwield

    set id [mc:makeid $n]

    if {![mc:check $id 1]} { return }
    if {![info exists liv($id)]} { return }
    if {[string first "run" $todo($id)] != -1} { return }
    set todo($id) [lappend todo($id) "run"]
    mc:msg $n $ct(37)
    if { $prc($id) != 0 } {
        mc:say [xformat3 $ct(36) [mc:getstat sex $id] [ms:dfl [mc:getstat nick $id]]]
        set prc($id) 0
        mc:checkend
    }
    set todo($id) [lsort -ascii $todo($id)]
    putlog [ms:dfl "todo\($col(red)[mc:getstat nick $id]$col(cl)\) = $col(mag)$todo($id)$col(cl)"]
}

proc mc:plist {n uh h c t} {
    global mcs mc ct cth mcr mcc mce ts tl ti tv th ta tg te todo liv param lastlist mcoptions

    set id [mc:makeid $n]

    if {![mc:check $id 1]} { return }
    if {[info exist lastlist] && $lastlist > [clock seconds]} { return }

    set mcoptions(sendlist) 1
    foreach ls [mc:list [mc:modeok $id "exlist"]] { mc:msg $n $ls }
    set mcoptions(sendlist) 0

    set lastlist [expr [clock seconds] + $mc(lastlist)]
}

proc mc:mclear {n uh h t} {
    global mcs mc ct cth mcr mcc mce ts tl ti tv th ta tg te todo liv param prc killed
    global cleardo interval isize
    global thicoll
    global col
    global allowwield

    set id [mc:makeid $n]

    if { ![mc:check $id 1] } { return }
    if { ![info exists liv($id)] } { return }
    ###    !  
    if { [info exist killed($id)] && $killed($id) == 1 } { return }
    if {[array exist allowwield] && [info exist allowwield($id)]} {
      mc:msg $n $ct(dow3)
      return
    }

    if { $prc($id)==0 } { mc:say [xformat3 $ct(clearm) [mc:getstat sex $id] [mc:nohighlight [ms:dfl [mc:getstat nick $id]]]] }

    set todo($id) ""
    set prc($id) 100
    mc:msg $n $ct(clearo)

    ###       
    if { $cleardo($id) > 0 } {
        incr cleardo($id) -1
        cleartimers
        incr isize
        if { $isize == 0 } { incr isize }
        mc:killghost
    }

    putlog [ms:dfl "todo\($col(red)[mc:getstat nick $id]$col(cl)\) = $col(mag)CLEAR$col(cl)"]
}

proc mc:mdo {n uh h t} {
    global mc mcs ct cth ctdo mcr mcc mce ts tl ti twis tv th ta tg te todo liv param nnick prc killed oldtodo
    global mg mr skill _skill
    global thicoll
    global col
    global allowwield

    set id [mc:makeid $n]

    if { ![mc:check $id 1] } { return }
    if { ![info exists liv($id)] } { return }
    ###    !  
    if { [info exist killed($id)] && $killed($id) == 1 } { return }

    if { [llength $t] >= 2 } {
        set t [lreplace $t 1 1 [tolower [lindex $t 1]] ]
    }

    if { [llength $t] == 2 && [lindex $t 1] == "r" } {
        set be $prc($id)
        if { [info exist oldtodo($id)] } {
            if { $prc($id) <= 0 } { set be 0 }
            set todo($id) ""
            set prc($id) 100
            foreach dd $oldtodo($id) {
                if { [info exist liv([lindex $dd 2])] } {
                    set todo($id) [lappend todo($id) $dd]
                    set prc($id) [expr $prc($id) - [lindex $dd 1]]
                }
            }
        }
        set t [lindex $t 0]
        if { $prc($id) == 0 && $be != 0 } {
            mc:say [xformat3 $ct(36) [mc:getstat sex $id] [mc:nohighlight [ms:dfl [mc:getstat nick $id]]]]
            mc:checkend
        }
        putlog [ms:dfl "todo\($col(red)[mc:getstat nick $id]$col(cl)\) = $col(mag)$todo($id)$col(cl)"]
    }

    if {[lindex [split $t] 1] == "w"} {
      foreach dodo $todo($id) {
        if {[lindex $dodo 0]=="wield"} {
          mc:msg $n $ct(dow1)
          return
        } elseif {[lindex $dodo 0]!="run"} {
          mc:msg $n $ct(dow0)
          return
        }
      }
      lappend todo($id) "wield"
      set prc($id) 0
      set allowwield($id) 1
      putlog [ms:dfl "todo\($col(red)[mc:getstat nick $id]$col(cl)\) = $col(mag)$todo($id)$col(cl)"]
      mc:msg $n $ct(dow2)
      mc:checkend
      return
    }

    if { [llength $t] == 1 } {
        if { $todo($id) == "" || $todo($id) == "run" } {
            mc:msg $n $ct(27)
            return
        }
        set tout ""
        foreach dodo $todo($id) {
            switch -- [lindex $dodo 0] {
                a { set tto "$ctdo([lindex $dodo 0])\(03[lindex $dodo 1]%10\)  06[ms:dfl $nnick([lindex $dodo 2])]10" }
                p { set tto "$ctdo([lindex $dodo 0])\(03[lindex $dodo 1]%10\)  06[ms:dfl $nnick([lindex $dodo 2])]10" }
                h { set tto "$ctdo([lindex $dodo 0])\(03[lindex $dodo 1]%10\)  06[ms:dfl $nnick([lindex $dodo 2])]10" }
                n { set tto "$ctdo([lindex $dodo 0])\(03[lindex $dodo 1]%10\)" }
                m { set tto "$ctdo([lindex $dodo 0]) [lindex $mg([lindex $dodo 3]) 0]\(03[lindex $dodo 1]%10\)  06[ms:dfl $nnick([lindex $dodo 2])]10" }
                s { set tto "$ctdo([lindex $dodo 0]) [lindex $skill([lindex $dodo 3]) 0]\(03[lindex $dodo 1]%10\)  06[ms:dfl $nnick([lindex $dodo 2])]10" }
                l { set tto "$ctdo([lindex $dodo 0])\(03[lindex $dodo 1]%10\)  06[ms:dfl $nnick([lindex $dodo 2])]10" }
                wield { set tto "04 10" }
                run { set tto "04   10" }
            }
            set tout [lappend tout [mc:fuck $tto]]
        }
        set tout "[mc:unfuck [format $ct(28) [join $tout ", "] $prc($id)]]"
        mc:msg $n $tout
        return
    }
    if { ![mc:checkin [lindex $t 1] "aphnmsl"] } {
        mc:msg $n $cth(2)
        return
    }
    set aprc -1
    set atype [lindex $t 1]
    set awho 0
    if { [llength $t] > 2 } {
        if { $atype == "n" } {
            set aprc [lindex $t 2]
        } else {
            set awho [lindex $t 2]
            if { ![isnumber $awho] && $awho == "all" } {
                set awho 0
            } elseif { ![isnumber $awho] } {
                if { [lsearch -exact $mc(list) [mc:makeid $awho]] == -1 } {
                    mc:msg $n $ct(24)
                    return
                } else {
                    set awho [lsearch -exact $mc(list) [mc:makeid $awho]]
                    incr awho
                }
            } elseif { $awho < 1 || $awho > [array size liv] } {
                mc:msg $n $ct(24)
                return
            }
            set awho [expr $awho - 1]
            if { $awho >= 0 } { set awho2 [lindex $mc(list) $awho] }
        }
    } else {
        if { $atype == "p" || $atype == "h" || $atype == "n" } {
            set awho2 $id
        } else {
            mc:msg $n $cth(2)
            return
        }
    }
    if { $atype == "n" } {
        set awho2 $id
    }
    if {$atype == "l" } {
      set aprc 10
    } elseif { [llength $t] > 3 } {
        if { [lindex $t 3] == "-" } {
            set aprc $prc($id)
        } else {
            set aprc [lindex $t 3]
        }
    } else {
        if { $aprc == -1 } {
            set aprc $prc($id)
        }
    }
    if {[isnumber $aprc]} { set aprc [expr round($aprc)] }
    if { $awho != -1 && (![isnumber $aprc] || $aprc < 1 || $aprc > $prc($id)) } {
        mc:msg $n [format $cth(2a) $prc($id)]
        return
    }
    if { $aprc == 0 } {
        mc:msg $n $cth(2b)
        return
    }

    ###      
    set proh ""

    foreach tmcol [array names thicoll] {
        if { ![mc:fullcoll $id $tmcol] } { continue }

        set isproh 0

       # putlog "NODO: [mc:wgetcoll $col nodo]"
       # putlog "-"

        foreach nodo [mc:wgetcoll $tmcol nodo] {
            if { [lindex $nodo 0] != $atype || $isproh == 1 } { continue }

            switch -- $atype {
                "a" {
                    if { [lindex $nodo 1] == 0 } {
                        set proh [lappend proh [format $cth(do.no.ele) [mc:wgetcoll $tmcol name]] ]
                        set type ""
                    }
                    if { [lindex $nodo 1] == 1 } {
                        set proh [lappend proh [format $cth(do.no.ele) [mc:wgetcoll $tmcol name]] ]
                        set type " "
                    }
                    if { [lindex $nodo 1] == 2 && $awho2 == $id } {
                        set proh [lappend proh [format $cth(do.no.ele) [mc:wgetcoll $tmcol name]] ]
                        set type " "
                    }
                    if { [lindex $nodo 1] == 3 && $awho2 != $id } {
                        set proh [lappend proh [format $cth(do.no.ele) [mc:wgetcoll $tmcol name]] ]
                        set type " "
                    }

                    if { [llength $nodo] > 2 } {
                        set found ""
                        foreach e [mc:getstat eq $id] {
                            if { [lsearch -exact [mc:getstat wield $id] [lindex $e 1] ] != -1 && [lindex $e 2] == 1 } {
                                set found [lappend found $e]
                            }
                        }

                        if { $found != "" } {
                            foreach nd [lrange $nodo 2 end] {
                                set typefound 0
                                foreach weapon $found {
                                    if { [mc:wget [lindex $weapon 1] weapon $id] == [lindex $nd 0] } {
                                        set typefound 1
                                    }
                                }
                                if { $typefound == 0 } { continue }
                                if { [llength $nd] > 1 } {
                                    set pars [split [lindex $nd 1] ","]
                                    foreach wear $pars {
                                        ###         
                                        foreach weapon $found {
                                            if { [lindex $weapon 3] == $wear } {
                                                set isproh 1
                                            }
                                        }
                                    }
                                } else {
                                    ###         
                                    set isproh 1
                                }
                            }
                        }
                    } else {
                        ###           
                        set isproh 1
                    }

                    if { $isproh == 0 } {
                        set proh [lreplace $proh end end]
                    }
                }
                default {
                    if { [lindex $nodo 1] == 0 } {
                        set proh [lappend proh [format $cth(do.no.ele) [mc:wgetcoll $tmcol name]] ]
                        set type ""
                    }
                    if { [lindex $nodo 1] == 1 } {
                        set proh [lappend proh [format $cth(do.no.ele) [mc:wgetcoll $tmcol name]] ]
                        set type " "
                    }
                    if { [lindex $nodo 1] == 2 && $awho2 == $id } {
                        set proh [lappend proh [format $cth(do.no.ele) [mc:wgetcoll $tmcol name]] ]
                        set type " "
                    }
                    if { [lindex $nodo 1] == 3 && $awho2 != $id } {
                        set proh [lappend proh [format $cth(do.no.ele) [mc:wgetcoll $tmcol name]] ]
                        set type " "
                    }
                }
            }
        }
    }
    if { $proh != "" } {
        set suffix ""
        if { [llength $proh] > 1 } {
            set suffix ""
        }
        set proh [join $proh ", "]
        mc:msg $n [format $cth(do.no.col) "!do $atype" $type $suffix $proh]
        return
    }

    ###       100%
    set manaprc 1.0

    foreach tal [mc:getstat inv $id] {
        set tid [lindex $tal 0]
        set tcount [expr [llength $tal] - 1]
        if { $tcount <= 0 } { continue }

        switch -- $tid {
            zad {
            ###  
                set manaprc [expr $manaprc - $tcount * [mc:wgettal $tid param1] * 0.01]
                if { $manaprc < 0.1 } { set manaprc 0.1 }
            }
        }
    }

    set dotype "$atype $aprc"
    switch -- $atype {
        l {
            foreach dodo $todo($id) {
              if { [lindex $dodo 0] == "l" } {
                mc:msg $n $cth(do.l)
                return
              }
            }

            set prc($id) [expr $prc($id) - $aprc]
            set dotype [lappend dotype $awho2]
            mc:msg $n [format $ct(do.l) [ms:dfl $nnick($awho2)] $aprc $prc($id)]
        }
        a {
            #if {$mcr($id) == $mcr($awho2)}
            #    mc:msg $n $cth(do.a)
            #    return
            #

            set catc 0
            set alrdatt 0
            foreach dodo $todo($id) {
                if { [lindex $dodo 0] == "a" } {
                    incr catc
                    if { [lindex $dodo 2] == $awho2 } { set alrdatt 1 }
                }
            }

            if { [mc:getstat prof $id] != "l" } {
                set maxtarg 1
            } else {
                set maxtarg [expr round(($twis($id) * 0.7 + $ts($id) * 0.3) / 4)]
                if { $maxtarg < 1 } { set maxtarg 1 }
            }

            if { $catc == $maxtarg && $alrdatt == 0 } {
                mc:msg $n [format $cth(2c) $maxtarg]
                return
            }

            if {$id == $awho2 && $mc(noselfattack) } {
              mc:msg $n $ct(24a)
              return
            }
            set dotype [lappend dotype $awho2]
            set prc($id) [expr $prc($id) - $aprc]
           # if { [mc:getstat prof $id] != "l" || $catc == $maxtarg }
           # if { $catc == $maxtarg } {
                set olddd ""
                foreach dodo $todo($id) {
                    if { [lindex $dodo 0] == "a" && [lindex $dodo 2] == $awho2 } {
                        set aprc [expr $aprc + [lindex $dodo 1]]
                        set dotype "$atype $aprc $awho2"
                    } else {
                        set olddd [lappend olddd $dodo]
                    }
                }
                set todo($id) $olddd
           # }
            mc:msg $n [format $ct(25) [ms:dfl $nnick($awho2)] $aprc $prc($id)]
        }
        p {
            if { $awho >= 0 } {
                if {$mcr($id) != $mcr($awho2)} {
                    mc:msg $n $cth(do.p)
                    return
                }

                set dotype [lappend dotype $awho2]
                set prc($id) [expr $prc($id) - $aprc]
                set olddd ""
                foreach dodo $todo($id) {
                    if { [lindex $dodo 0] == "p" && [lindex $dodo 2] == $awho2 } {
                        set aprc [expr $aprc + [lindex $dodo 1]]
                        set dotype "$atype $aprc $awho2"
                    } else {
                        set olddd [lappend olddd $dodo]
                    }
                }
                set todo($id) $olddd
                mc:msg $n [format $ct(26) [ms:dfl $nnick($awho2)] $aprc $prc($id)]
            } elseif { $awho == -1 } {
                set teamsize 0
                foreach e [array names liv] {
                    if { $mcr($id) == $mcr($e) } { incr teamsize }
                }

                if { $aprc > 0 && $aprc <= $prc($id) } {
                    set ostatok [expr $aprc % $teamsize]
                    if { $ostatok == $aprc } {
                        mc:msg $n [format $cth(2a) $prc($id)]
                        return
                    }
                    set procent [expr ($aprc - $ostatok) / $teamsize]
                    set ostatok [expr $prc($id) - $procent * $teamsize]
                } elseif { $aprc < 0 && [expr abs($aprc)] <= $prc($id) } {
                    if { [expr abs($aprc) * $teamsize] > $prc($id) } {
                        mc:msg $n [format $cth(2a) $prc($id)]
                        return
                    }
                    set ostatok [expr $prc($id) - abs($aprc) * $teamsize]
                    set procent [expr abs($aprc)]
                } else {
                    mc:msg $n [format $cth(2a) $prc($id)]
                    return
                }

               # putlog "PRT ALL: prc = $prc($id), teamsize = $teamsize, procent = $procent, ostatok = $ostatok"
                foreach e [array names liv] {
                    set olddd ""
                    set dotype ""
                    if { $mcr($id) == $mcr($e) } {
                        set dotype "p $procent $e"
                        foreach dodo $todo($id) {
                            if { [lindex $dodo 0] == "p" && [lindex $dodo 2] == $e } {
                                set procen [expr [lindex $dodo 1] + $procent]
                                set dotype "p $procen $e"
                            } else {
                                set olddd [lappend olddd $dodo]
                            }
                        }
                        set todo($id) $olddd
                        set todo($id) [lappend todo($id) $dotype]
                    }
                }
                set prc($id) $ostatok
                mc:msg $n [format $ct(26b) $teamsize $procent $prc($id)]
            }
        }
        h {
            set prc($id) [expr $prc($id) - $aprc]
            set dotype [lappend dotype $awho2]
            set olddd ""
            foreach dodo $todo($id) {
                if {([lindex $dodo 0] == "h") && ([lindex $dodo 2] == $awho2)} {
                    set aprc [expr $aprc + [lindex $dodo 1]]
                    set dotype "$atype $aprc $awho2"
                } else {
                    set olddd [lappend olddd $dodo]
                }
            }
            set todo($id) $olddd
            mc:msg $n [format $ct(29) [ms:dfl $nnick($awho2)] $aprc $prc($id)]
        }
        m {
            if { [llength $t] < 5 } {
                mc:msg $n $cth(30)
                return
            }
            if { [mc:getstat prof $id] != "p" } {
                foreach dodo $todo($id) {
                    if { [lindex $dodo 0] == "m" } {
                        mc:msg $n $cth(31)
                        return
                    }
                }
            }
            set mtype [mc:tolat [lindex $t 4]]
            set mtype "[string index $mtype 0][mc:getstat prof $id][string index $mtype 1]"
            set mfound 0
            foreach mmm [mc:getstat magic $id] {
                if { [lindex $mmm 0] == $mtype } {
                    set mfound [lindex $mmm 1]
                    break
                }
            }
            if { $mfound == 0 } {
                mc:msg $n $cth(do.no.sp)
                return
            }

            ###      
            set proh ""
            foreach tmcol [mc:collprohibitions $id nospell $mtype] {
                set proh [lappend proh [format $cth(do.no.spe) [mc:wgetcoll $tmcol name]] ]
            }
            if { $proh != "" } {
                set suffix ""
                if { [llength $proh] > 1 } {
                    set suffix ""
                }
                set proh [join $proh ", "]
                mc:msg $n [format $cth(do.no.spc) $suffix $proh]
                return
            }

            if { [lindex $mr(${mtype}a) 0] == 1 && [lindex $mr(${mtype}a) 1] == 0 && [lindex $mr(${mtype}a) 2] == 0 } {
                set awho2 $id
            }

            if { $awho2 == $id && [lindex $mr(${mtype}a) 0] == 0 } {
                mc:msg $n $cth(do.no.sp1)
                return
            }
            if { $awho2 != $id && $mcr($id) == $mcr($awho2) && [lindex $mr(${mtype}a) 1] == 0 } {
                mc:msg $n $cth(do.no.sp2)
                return
            }
            if { $mcr($id) != $mcr($awho2) && [lindex $mr(${mtype}a) 2] == 0 } {
                mc:msg $n $cth(do.no.sp3)
                return
            }

            ###   ,  
            set nmana ""
            if { $ta($id) < [expr2 1 [lindex $mg($mtype) 1] * $manaprc] } { set nmana $ct(29an) }

            set dotype [lappend dotype $awho2]
            set dotype [lappend dotype $mtype]
            set dotype [lappend dotype $mfound]
            set prc($id) [expr $prc($id) - $aprc]
            mc:msg $n "[format $ct(29a) [lindex $mg($mtype) 0] [ms:dfl $nnick($awho2)] $aprc $prc($id)] $nmana"
        }
        s {
            if { [llength $t] < 5 } {
                mc:msg $n $cth(30s)
                return
            }
            foreach dodo $todo($id) {
                if { [lindex $dodo 0] == "s" } {
                    mc:msg $n $cth(31s)
                    return
                }
            }
            set mtype [mc:tolat [lindex $t 4]]
            set mfound 0
            foreach mmm [mc:getstat skill $id] {
                if { [lindex $mmm 0] == $mtype } {
                    set mfound [lindex $mmm 1]
                    break
                }
            }
            if { $mfound == 0 } {
                mc:msg $n $cth(do.no.sk)
                return
            }

            ###      
            set proh ""
            foreach tmcol [mc:collprohibitions $id noskill $mtype] {
                set proh [lappend proh [format $cth(do.no.ske) [mc:wgetcoll $tmcol name]] ]
            }
            if { $proh != "" } {
                set suffix ""
                if { [llength $proh] > 1 } {
                    set suffix ""
                }
                set proh [join $proh ", "]
                mc:msg $n [format $cth(do.no.skc) $suffix $proh]
                return
            }

            if {[mc:skill:checkflag $mtype nodos]} {
              if {[expr [mc:skill:switch $id $mtype] - 1]} {
                set frm $cth(do.skon)
              } {
                set frm $cth(do.skoff)
              }
              mc:msg $n [format $frm [lindex $skill($mtype) 0]]
              return
            }

            if { $mtype == "wd" || $mtype == "we" || $mtype == "ld" || $mtype == "le" } {
                set awho2 $id
            }
            if { ($awho2 == $id || $mcr($id) == $mcr($awho2)) && ($mtype == "wa" || $mtype == "wb" || $mtype == "wc" || $mtype == "la" || $mtype == "lb" || $mtype == "lc") } {
                mc:msg $n $cth(do.no.sk1)
                return
            }

            ###   ,  
            set nmana ""
            if { $ta($id) < [expr2 1 [lindex $_skill($mtype$mfound) 4] * $manaprc] } { set nmana $ct(29sn) }

            set dotype [lappend dotype $awho2]
            set dotype [lappend dotype $mtype]
            set dotype [lappend dotype $mfound]
            set prc($id) [expr $prc($id) - $aprc]
            mc:msg $n "[format $ct(29s) [lindex $skill($mtype) 0] [ms:dfl $nnick($awho2)] $aprc $prc($id)] $nmana"
        }
        n {
            set dotype [lappend dotype $awho2]
            set prc($id) [expr $prc($id) - $aprc]
            set olddd ""
            foreach dodo $todo($id) {
                if { [lindex $dodo 0] == "n" } {
                    set aprc [expr $aprc + [lindex $dodo 1]]
                    set dotype "$atype $aprc $awho2"
                } else {
                    set olddd [lappend olddd $dodo]
                }
            }
            set todo($id) $olddd
            mc:msg $n [format $ct(29c) $aprc $prc($id)]
        }
    }
    if { $awho != -1 } { set todo($id) [lappend todo($id) $dotype] }
    set todo($id) [lsort -ascii $todo($id)]
    if { $prc($id) == 0 } { mc:say [xformat3 $ct(36) [mc:getstat sex $id] [mc:nohighlight [ms:dfl [mc:getstat nick $id]]]] }
    putlog [ms:dfl "todo\($col(red)[mc:getstat nick $id]$col(cl)\) = $col(mag)$todo($id)$col(cl)"]

    mc:checkend
    return 1
}

proc mc:checkend {} {
    global mc mcs ct mcr mcc mce ts tl ti tv th ta tg te todo liv param nnick prc oldtodo
    global col

    set theend 1

    foreach id [array names liv] {
        if {$prc($id) != 0} {
            set theend 0
        }
    }
    if { $theend == 1 } {
        cleartimers
        set secs 15
        if { [info exists mc(bot.public)] && $mc(bot.public) != "" && [islinked $mc(bot.public)] } {
            set secs 10
        }
        mc:say [format $ct(round4) $secs]
        putlog "$col(red)PRE-ROUND $secs SECONDS$col(cl)"
        utimer $secs { mc:roundend }
    }
}

proc mc:mstat {n uh h t} {
    global mcs mc ct mcr mcc mce ts tl ti twis tv th ta tg te todo liv param nnick

    set id [mc:makeid $n]

    if {![mc:check $id -]} { return }

    if {$mc(phase) == 0 || ([array exists liv] && ![info exists liv($id)])} {
        mc:msg $n "$ct(21) [mc:gethark $id]"
        return
    }

    if {$mc(phase) < 1} { return }
    set id [mc:makeid $n]

    if {![info exists liv($id)]} { return }
    if {[mc:getstat prof $id] == "w" || [mc:getstat prof $id] == "l"} {
        mc:msg $n "$ct(21) [format $ct(20w) $te($id) $th($id) [mc:getmaxhp $id] $ta($id) [mc:getmaxmp $id] [mc:getstat bonus $id] $ts($id) [mc:getstat rstr $id] $tl($id) [mc:getstat rdex $id] $twis($id) [mc:getstat rwis $id] $ti($id) [mc:getstat rint $id] $tv($id) [mc:getstat rcon $id]]"
    } else {
        mc:msg $n "$ct(21) [format $ct(20)  $te($id) $th($id) [mc:getmaxhp $id] $ta($id) [mc:getmaxmp $id] [mc:getstat bonus $id] $ts($id) [mc:getstat rstr $id] $tl($id) [mc:getstat rdex $id] $twis($id) [mc:getstat rwis $id] $ti($id) [mc:getstat rint $id] $tv($id) [mc:getstat rcon $id]]"
    }
}

proc mc:mmag {n uh h t} {
    global mcs mc ct cth mcr cth ct mcc mce ts tl twis ti tv th ta tg te todo liv param nnick
    global mg mr

    set id [mc:makeid $n]
    if {![mc:check $id -]} { return }
    if {[mc:getstat prof $id] != "m" && [mc:getstat prof $id] != "p"} { return }
    set pr [mc:getstat magic $id]

    foreach p $pr {
        if {[lindex $p 1] == "-"} {
            mc:msg $n $cth(27)
            return
        }
        set llev [string index [lindex $p 0] 0]
        set magcode [string replace [lindex $p 0] 1 1 ""]
        if {[array exist mmma] && [info exist mmma($llev)]} {
            set mmma($llev) [lappend mmma($llev) [mc:fuck [format $cth(28) $magcode [format $cth(28$mr([lindex $p 0]t)) [lindex $mg([lindex $p 0]) 0]] [lindex $mg([lindex $p 0]) 1] [lindex $p 1]]]]
        } else {
            set mmma($llev) [mc:fuck [format $cth(28) $magcode [format $cth(28$mr([lindex $p 0]t)) [lindex $mg([lindex $p 0]) 0]] [lindex $mg([lindex $p 0]) 1] [lindex $p 1]]]
        }
    }
    for {set i 9} {$i >= 1} {incr i -1} {
        if {[info exist mmma($i)]} { mc:msg $n [mc:unfuck [format $cth(29) $i [join $mmma($i) ", "]]] }
    }
}

proc mc:mmagexplain {n uh h t} {
    global mcs mc ct cth mcr cth ct mcc mce ts tl twis ti tv th ta tg te todo liv param
    global mg me mr

    set id [mc:makeid $n]
    if {![mc:check $id -]} { return }

    if {[mc:getstat prof $id] != "m" && [mc:getstat prof $id] != "p"} { return }
    if {[llength $t] < 2} {
        mc:msg $n $cth(magexf)
        return
    }
    set mx [lindex $t 1]
    set mx "[string index $mx 0][mc:getstat prof $id][string index $mx 1]"
    if {![info exist me($mx)]} {
        mc:msg $n "$cth(magexn)"
        return
    }
   # set mfound 0
   # foreach mm [mc:getstat magic $id] {
   #     if {[lindex $mm 0] == $mx} {
   #         set mfound 1
   #         break
   #     }
   # }
   # if {$mfound == 0} {
   #     mc:msg $n $cth(magexo)
   #     return
   # }
    mc:msg $n [format $cth(magexd) [lindex $mg($mx) 0] $me($mx)]

    ###    
    set out ""
    if {[lindex $mr(${mx}a) 0] == 1} { set out [lappend out $cth(magexz1)] }
    if {[lindex $mr(${mx}a) 1] == 1} { set out [lappend out $cth(magexz2)] }
    if {[lindex $mr(${mx}a) 2] == 1} { set out [lappend out $cth(magexz3)] }
    if {$out != ""} {
        set out [join $out ", "]
        mc:msg $n [format $cth(magexz) $out]
    }
}

proc mc:mlearn {n uh h t} {
    global mcs mc ct cth mcr cth ct mcc mce ts tl twis ti tv th ta tg te todo liv param
    global mg

    set id [mc:makeid $n]

    if { ![mc:check $id -] } { return }
    if { [mc:getstat prof $id] != "m" && [mc:getstat prof $id] != "p" } { return }

    set pr [mc:getstat magic $id]
    if {[llength $t] < 2} {
        mc:msg $n $cth(35)
        return
    }
    set lev [lindex $t 1]
    if {(![isnumber $lev]) || ($lev < 1) || ($lev > 5)} {
        mc:msg $n $cth(36)
        return
    }
    set prlev [mc:getstat level $id]
#    if {$lev > $prlev} {
#        mc:msg $n [format $cth(37) $prlev]
#        return
#    }
    if {[expr ($lev - 1) * 2 + 1] > $prlev} {
        #mc:msg $n [format $cth(37) $prlev]
        mc:msg $n $cth(37)
        return
    }

#    if {$lev > [mc:getstat bonus $id]}
    if {1 > [mc:getstat bonus $id]} {
        mc:msg $n $cth(38)
        return
    }
    set avmagnum 0
    set avmagnam ""
    foreach mgg [array names mg] {
        if {([string index $mgg 0] == $lev) && ([string index $mgg 1] == [mc:getstat prof $id])} {
            incr avmagnum
            set avmagnam [lappend avmagnam $mgg]
        }
    }
    if {$avmagnum == 0} {
        mc:msg $n $cth(39)
        return
    }
    set hvmagnum 0
    set hvmaglev 0
    foreach mggg $pr {
        set mgg [lindex $mggg 0]
        if {([string index $mgg 0] == $lev)} {
            incr hvmagnum
            incr hvmaglev [lindex $mggg 1]
        }
        set mghave($mgg) [lindex $mggg 1]
    }
    if {[expr $avmagnum * 3] <= $hvmaglev} {
        mc:msg $n $cth(41)
        return
    }
    #set ver [expr ($prlev - $lev + 3) * 25]
    # (<_> - <> + 3) * 25
    set ver [expr ($prlev - (($lev - 1) * 2 + 1) + 3) * 25]
    # +5%   .
    set ver [expr $ver + 5 * [mc:getstat remort $id]]

    if {$ver > 100} { set ver 100 }

    set mrand [mc:die 1d100]
    putlog "mrand == $mrand !! ver == $ver"
#    mc:setstat bonus $id [expr [mc:getstat bonus $id] - $lev]
    mc:setstat bonus $id [expr [mc:getstat bonus $id] - 1]
    if {$mrand > $ver} {
        mc:msg $n $cth(40)
        return
    }
    set maglearn 0
    while {$maglearn == 0} {
        set lll [expr [mc:die 1d$avmagnum] - 1]
        set lll [lindex $avmagnam $lll]
        if {(![info exist mghave($lll)]) || ($mghave($lll) < 3)} {
            set maglearn $lll
        }
    }
    if {![info exist mghave($lll)]} {
        mc:msg $n [format $cth(42) [lindex $mg($lll) 0]]
        set mghave($lll) 1
    } else {
        mc:msg $n [format $cth(43) [lindex $mg($lll) 0] [expr $mghave($lll) + 1]]
        set mghave($lll) [expr $mghave($lll) + 1]
    }
    set mgd ""
    foreach i [array names mghave] {
        set mgd [lappend mgd "$i $mghave($i)"]
    }
    mc:setstat magic $id $mgd
    mc:sortmg $id
}

proc mc:sortmg {id} {
    set oldmagic [mc:getstat magic $id]
    set newmagic ""

    if {[llength $oldmagic] == 1} { return }

    for {set i 0} {$i < [llength $oldmagic]} {incr i} {
        set pos $i
        set num [lindex [lindex $oldmagic $i] 0]

        for {set j [expr $i + 1]} {$j < [llength $oldmagic]} {incr j} {
            if {$num > [lindex [lindex $oldmagic $j] 0]} {
                set pos $j
                set num [lindex [lindex $oldmagic $j] 0]
            }
        }

        set newmagic [lappend newmagic [lindex $oldmagic $pos]]
        set oldmagic [lreplace $oldmagic $pos $pos]
        incr i -1
    }

    mc:setstat magic $id $newmagic
}

proc mc:_massmsg {nks txt} {
  foreach {n1 n2 n3 n4 n5} $nks {
    set ddd [join "$n1 $n2 $n3 $n4 $n5" ","]
#    putlog "  ddd: $ddd"
    foreach ls $txt {
      if { [mc:checkflag "F"] } {
        putquick "PRIVMSG [ms:dfl "$ddd :$ls"]"
      } else {
        putserv "PRIVMSG [ms:dfl "$ddd :$ls"]"
      }
    }
  }
}

proc mc:start {} {
    global mcs mc ct mcr mcc mce mcoptions mctemp
    global ts tl ti twis tv th ta tg te
    global todo liv param nnick prc roundstart livnumber mcnt oldtodo countt countr
    global cleardo interval isize
    global col

    set mc(phase) 1

    putlog " "
    putlog "$col(red)ROUND BEGIN$col(cl)"

    set out [format $ct(round2) [mc:adjending [expr abs($countr) + 1]] ]
    if { $countr > 0 } {
        set out "$out [format $ct(round6) [clock format [expr [unixtime] - $countt - 3600*3 + $mc(timeshift)] -format "%H:%M:%S"] ]"
    }
    mc:say $out

    mc:weather:set

    mc:createlist

    if {[mc:istotal]} { mc:tot:startround $mc(list) }
    set mcoptions(sendlist) 1

    set mctemp(roundwarning) 0

    cleartimers
    set roundstart [clock seconds]
    set livnumber [array size liv]

    set listtosend ""
    set elisttosend ""
    set directsend ""
    foreach e [array names liv] {
        if { [array exist mcnt] && [info exist mcnt($e)] } {
            set directsend [lappend directsend $e]
        } else {
            if {[mc:modeok $e "exlist"]} {
              set elisttosend [lappend elisttosend $e]
            } else {
              set listtosend [lappend listtosend $e]
            }
        }
        set todo($e) ""
        set prc($e) 100
        set quited($e) 2
        set cleardo($e) 1
    }
    if {$mc(massmsg)} { set mtmp "\(mass\)" } { set mtmp "" }
    putlog "$col(hcyn)DirectSend$col(hblk):$col(cl) $directsend$col(cl)"
    putlog "$col(cyn)ListToSend$col(hblk)$mtmp :$col(cl) $listtosend$col(cl)"
    putlog "$col(cyn)eListToSend$col(hblk)$mtmp:$col(cl) $elisttosend$col(cl)"

    foreach nn $directsend {
        set list [mc:list [mc:modeok $nn "exlist"]]
        set nn [ms:dfl $nn]
        foreach ls $list {
            mc:msg $nn [ms:dfl "$ls"]
        }
    }
#    putlog "MassMSG: $mc(massmsg)"
    if { $mc(massmsg) == 1 } {
      if {$listtosend!=""} {
        mc:_massmsg $listtosend [mc:list 0]
      }
      if {$elisttosend!=""} {
        mc:_massmsg $elisttosend [mc:list 1]
      }
    } else {
        foreach nck $listtosend {
            set list [mc:list [mc:modeok $nn "exlist"]]
            set nck [ms:dfl $nck]
            foreach ls $list {
                mc:msg $nnick($nck) [ms:dfl "$ls"]
            }
        }
    }

    set mcoptions(sendlist) 0

    putlog "$col(cyn)End of list sending.$col(cl)"
    putlog "-"

    set asize [max [array size liv] $mc(avegamers)]
    set interval [expr2 0 $mc(avegamers) * 1.0 / log($asize / 4.0) ]
    set interval [max 8 $interval]
    set isize    [max 9 [array size liv]]

    mc:killghost
}

proc mc:tlist {} {
    global mc

    set i 30
    while {$i > 0} {
        set i2 [max $i $mc(avegamers)]
        set int [expr2 0 $mc(avegamers) * 1.0 / log($i2 * 1.0 / 5)]
        set isize [max $$i 10]
        putlog "[format "%.2d  * %.2d . == %.3d    %s" $i $int [expr $int * $isize] [clock format [expr $int * $isize] -format "\(%M:%S\)"]]"
        incr i -1
    }
}

proc mc:getdescript {id flag} {
   if {$flag} {
     set pl "l m w p"
     set plc "07 06 04 09"

     set pr "[lindex $plc [lsearch -exact $pl [mc:getstat prof $id]]]"
     set remort [mc:getstat remort $id]
     set lvl [mc:getstat level $id]
     if {$remort != 0} { set pr "$pr$remort/" }
     return "$pr$lvl"
   } else {
     return ""
   }
}

proc mc:list {flag} {
    global mc mcs mcr mce ct cth liv

    set list ""
    set temp ""

    for { set i 0 } { $i < [llength $mc(list)] } { incr i } {
        set id [lindex $mc(list) $i]
        if { $mc(multilist) == 1 && [string length $temp] >= 360 } {
            set temp [join $temp]
            if {[lindex $temp end]==$ct(listdel)} { set temp [lreplace $temp end end] }
#            set temp [string trimright $temp " $ct(listdel)"]
            set temp [ms:dfl $temp]
            set list [lappend list "12: $temp 14"]
            set temp ""
        }
        set temp [lappend temp "03[expr $i + 1].10[mc:getstat nick $id][mc:getdescript $id $flag]"]
        if { $i < [expr [llength $mc(list)] - 1] && $mcr($id) != $mcr([lindex $mc(list) [expr $i + 1]]) } {
            set temp [lappend temp $ct(listdel)]
        }
    }
    if { $temp != "" } {
        set temp [join $temp]
        if {[lindex $temp end]==$ct(listdel)} { set temp [lreplace $temp end end] }
#        set temp [string trimright $temp " $ct(listdel)"]
        set temp [ms:dfl $temp]
        set list [lappend list "12: $temp 14"]
    }

    return $list
}
